Unit MNKU3_p;
interface
uses
SysUtils, Math, { Delphi }
Lstruct, Lfunc;

procedure MNKU3(N :Integer; var NG :Integer; var I1 :Array of Integer;
                var P :Array of Real; var XF :Array of Real;
                var XT :Array of Real; HT :Real; var G :Array of Real;
                var GE :Array of Real; var CGE :Array of Real;
                GRAD :Proc_F2_MN);

implementation

procedure MNKU3(N :Integer; var NG :Integer; var I1 :Array of Integer;
                var P :Array of Real; var XF :Array of Real;
                var XT :Array of Real; HT :Real; var G :Array of Real;
                var GE :Array of Real; var CGE :Array of Real;
                GRAD :Proc_F2_MN);
var
I :Integer;
label
_1,_2,_3;
begin
{   BCEHE PAEHTA B TOKE XT=XF-HT*P }
I := 0;
_1:
I := I+1;
if ( I > N ) 
 then goto _3;
if ( I1[I-1] = 0 ) 
 then goto _2;
XT[I-1] := XF[I-1]-HT*P[I-1];
GE[I-1] := CGE[I-1];
goto _1;
_2:
XT[I-1] := XF[I-1];
goto _1;
_3:
GRAD(XT,G,GE,I1);
NG := NG+1;
end;

end.
